//{$WARNINGS OFF}
//{$WARN SYMBOL_PLATFORM OFF}
//{$WARN UNIT_PLATFORM OFF}
//=============================================================================
//  UNLHA32.DLLgpt@C̈kE𓀗pNX
//  VXeUNLHA32.DLLCXg[(o^)ĂKv
//
//  ̃jbǵCUNLAH32.DLL̃R}hCXƃXCb`IvVgp
//  k܂͉𓀂
//
//  k𓀃[eBeB쐬ړIł͂ȂCAvɊȒPȈkE
//  ̃[`gݍނ߂ɍ쐬
//
//-----------------------------------------------------------------------------
//  \bh
//
//  PackFiles     wt@C܂̓fBNg̃t@Ck
//  UnPackFiles   
//  MakeSFX       WinSFX32M`̎ȉ𓀏ɍ쐬
//  GetVersion    o[W擾
//
//-----------------------------------------------------------------------------
//
//  ygpz
//
//  TCg̃AvP[VށCR|[lgCR[hނ́C]ځCρCzz
//  (IWiCϔ)Ȃǂ͑SĎRłDppRłDACgp̋L
//  ڋ`܂DIWî̂pƂ邱Ƃ͋֎~܂D
//  ܂Czz̍ہCȂ闝R낤Ƃɑ㉿߂邱Ƃ֎~܂D
//  ȂC{TCg̃vOR[hgpƂɂĐCȂ
//  QCɊւĂ҂͈؊֗^Ȃ̂Ƃ܂DD
//
//-----------------------------------------------------------------------------
//
//  yz
//
//  2010N0511 J
//  2010N0514 is󋵃bZ[WpR[hǉ
//
//-----------------------------------------------------------------------------
//
//  ymFz
//
//  Windows XP(SP3) + Delphi2010(UP5) Pro + UNLHA32.DLL 2.65
//  Windows 7 U64 + Delphi2010(UP5) Pro + UNLHA32.DLL 2.65
//
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//=============================================================================
unit plArchieverLZH;

interface

uses
    Windows, SysUtils, Classes, Controls;

const
  //OŎgp萔(EXTRACTINGINFO\̗p)
  FNAME_MAX32 = 513 -1;
	ARCEXTRACT_BEGIN     = 0;	//Yt@C̏Jn
	ARCEXTRACT_INPROCESS = 1;	//Yt@C̓WJ
	ARCEXTRACT_END       = 2;	//I.֘AJ
	ARCEXTRACT_OPEN      = 3;	//Yɂ̏̊Jn
	ARCEXTRACT_COPY      = 4;	//[Nt@C̏߂

//-----------------------------------------------------------------------------
//  is󋵂̏i[p\̂̒`
//  Delphi2009ȍ~̎gplAnsiCharƖL
//  i[t@CTCYƏ񂾃TCY̓t@C11̒l(Ŝł͂Ȃ)
//-----------------------------------------------------------------------------
type
  PEXTRACTINGINFO = ^TEXTRACTINGINFO;
  TEXTRACTINGINFO = record
    dwFileSize       : DWORD;                                //i[t@CTCY
    dwWriteSize      : DWORD;                                //񂾃TCY
    szSourceFileName : array [0..FNAME_MAX32-1] of AnsiChar; //̃t@C
    dummy1           : array [0..2] of AnsiChar;             //_~[
    szDestFileName   : array [0..FNAME_MAX32-1] of AnsiChar; //̃tpX
    dummy            : array [0..2] of AnsiChar;             //_~[
  end;
 	LPEXTRACTINGINFO = ^TExtractingInfo;

//-----------------------------------------------------------------------------


var
  //̃jbggpAvŎis󋵗pbZ[W`
  WM_ARCEXTRACT : Cardinal;

type
  TplArchieverLZH = class(TComponent)
  private
    FHandle : HWND;
  protected
    FDllHandle : THandle;
    function Execute(Cmd: String; var AMsg: String): Boolean;
    function AddQuotedStr(Str: String): String;
    function GetBasePath(PathList: TStrings): String;
  public
		constructor Create( AOwner:TComponent ); override;
    destructor Destroy(); override;
    function PackFiles(SrcPathList: TStrings; DestFile: String;
      var AMsg: String): Boolean; overload;
    function PackFiles(SrcPath, DestPath: String; var AMsg: String):
      Boolean; overload;
    function UnPackFiles(SrcPath, DestPath: String; var AMsg: String): Boolean;
    function MakeSFX(SrcPath, DestPath: String; AutoRunFile: String;
      var AMsg: String): Boolean;
    function GetVersion: String;
  end;

implementation

{ TplArchieverLZH }

type
  TUnlha          = function (const hWnd: HWND; szCmdLine: LPCSTR; 
                              szOutput: LPSTR; dwSize: DWORD): Integer; stdcall;
  TUnlhaSetOwnerWindow   = function(_hwnd: HWND) : BOOL; stdcall;
  TUnlhaClearOwnerWindow = function() : BOOL; stdcall;
  TUnlhaGetVersin        = function (): WORD; stdcall;

var
  FUnlha                 : TUnlha;
  FUnlhaSetOwnerWindow   : TUnlhaSetOwnerWindow;
  FUnlhaClearOwnerWindow : TUnlhaClearOwnerWindow;
  FUnlhaGetVersion       : TUnlhaGetVersin;

const
  BUFF_SIZE = 8192;

//=============================================================================
//  Create
//=============================================================================
constructor TplArchieverLZH.Create(AOwner:TComponent);
begin
  inherited;

  FDllHandle := LoadLibrary('UNLHA32.DLL');
  if FDllHandle < HINSTANCE_ERROR then begin
    FDllHandle := 0;
  end else begin
    FHandle := TWinControl(AOwner).Handle;

    if WM_ARCEXTRACT = 0 then
      WM_ARCEXTRACT := RegisterWindowMessage('wm_arcextract');

    @FUnlha                 := GetProcAddress(FDllHandle, 'Unlha');
    @FUnlhaSetOwnerWindow   := GetProcAddress(FDllHandle, 'UnlhaSetOwnerWindow');
    @FUnlhaClearOwnerWindow := GetProcAddress(FDllHandle, 'UnlhaClearOwnerWindow');
    @FUnlhaGetVersion := GetProcAddress(FDllHandle, 'UnlhaGetVersion');

    FUnlhaSetOwnerWindow(FHandle);
  end;
end;

//=============================================================================
//  Destroy
//=============================================================================
destructor TplArchieverLZH.Destroy;
begin
  if FDllHandle <> 0 then FreeLibrary(FDllHandle);
  FDllHandle := 0;

  inherited;
end;

//=============================================================================
//  k\bh
//  OŊi[t@CύXꍇ͏Ƀt@C폜ȂƑÕt@C
//  c܂܂ƂȂ
//
//  SrcPathList
//    kΏۂ̃t@C܂̓fBNg̃XgDtpXŎw
//    ܂͊fBNgpXŎw肷
//  DestFile
//    k̃t@CDtpXŎw肷DgqȗLZHɂȂ
//  AMsg
//    UNLHA32.DLLԂbZ[W
//
//  HogeDir̂悤ȃfBNg܂߂ꍇ͈ȉ̂悤ɂ
//  pX̍Ō̃f~^(\)̗L͖Ȃ
//  []
//  SrcPathList.Add('D:\000\AAA.txt');
//  SrcPathList.Add('D:\000\BBB.doc');
//  SrcPathList.Add('D:\000\CCC.xls');
//  SrcPathList.Add('D:\000\HogeDir');
//=============================================================================
function TplArchieverLZH.PackFiles(SrcPathList: TStrings; DestFile: String;
  var AMsg: String): Boolean;
var
  BasePath  : String;
  Str       : String;
  FListStr  : String;
  i         : Integer;
  FCommand  : String;
begin
  Result := False;
  //DLL[hłĂȂ[hɎs
  if FDllHandle = 0 then exit;

  FListStr := '';
  if SrcPathList.Count = 1 then begin
    BasePath := ExcludeTrailingPathDelimiter(SrcPathList[0]);
    if DirectoryExists(BasePath) then begin
      BasePath := IncludeTrailingPathDelimiter(SrcPathList[0]);
      FListStr := '*';
    end else begin
      BasePath := ExtractFilePath(SrcPathList[0]);
      FListStr := AddQuotedStr(ExtractFileName(SrcPathList[0]));
    end;
  end else begin
    //fBNg߁C̊fBNg폜pXXg쐬
    BasePath := GetBasePath(SrcPathList);

    //UNLHA32.DLL̊֐ɓn"ň͂񂾕쐬(󔒂邱Ƃl)
    for i := 0 to SrcPathList.Count - 1 do begin
      Str := SrcPathList[i];
      FListStr := FListStr + AddQuotedStr(ExcludeTrailingPathDelimiter(Str)) + ' ';
    end;
  end;

  FCommand := 'a -a1 -r2 -x1 -l1 -jp0 -n1 ' +
              AddQuotedStr(DestFile) + ' '+
              AddQuotedStr(BasePath) + ' '+
              FListStr;

  Result := Execute(FCommand, AMsg);
end;

//=============================================================================
//  k\bh
//  PfBNg܂͒Pt@Cp
//=============================================================================
function TplArchieverLZH.PackFiles(SrcPath, DestPath: String;
  var AMsg: String): Boolean;
var
  SL : TStringList;
begin
  SL := TStringList.Create;
  try
    SL.Add(SrcPath);
    Result := PackFiles(SL, DestPath, AMsg);
  finally
    FreeAndNil(SL);
  end;
end;

//=============================================================================
//  𓀃\bh
//  𓀎̐io[vOXo[\ŏ㏑[h
//  ǎpt@C̏ꍇ́CmF̃_CAO\
//
//  SrcPath
//    𓀑Ώۂ̃t@C̃tpX
//  DestPath
//    𓀌̃fBNg(ŌɃf~^͕sv)
//    ݂ȂfBNgw肷Ɖ𓀂Ȃ(AMsgɋ󕶎Ԃ)
//  AMsg
//    UNLHA32.DLLԂbZ[W
//=============================================================================
function TplArchieverLZH.UnPackFiles(SrcPath, DestPath: String;
  var AMsg: String): Boolean;
var
  FCommand : String;
begin
  //DLL[hłĂȂ[hɎs
  Result := False;
  if FDllHandle = 0 then exit;

  FCommand := 'e '+ '-a1 -r2 -x1 -jp0 -c1 -m1 -n1 ' +
              AddQuotedStr(SrcPath) + ' ' +
              AddQuotedStr(IncludeTrailingPathDelimiter(DestPath));

  //^Ċ֐s
  Result := Execute(FCommand, AMsg);
end;

//=============================================================================
//  ȉ𓀏ɂ̍쐬(WinSFX32M`)
//  쐬ɂ̓WJ͂̏ɂfBNg
//  Windows 7 U64̏ꍇɂ̓vWFNg̃tH_ƂȂ)
//
//  SrcPath
//    ɍ쐬LZHɃt@C̃tpX
//  DestPath
//    쐬鎩ȉ𓀏Ƀt@C̃pXDtpXw肵ĂSrcPathƓ
//    fBNgɍ쐬
//    󔒕ɂSrcPath̃t@C̊gqEXEɂ̂ƂȂ
//  AutoRunFile
//    쐬𓀏ɂ𓀌Ɏst@C̎w
//    w肵Ȃꍇ͋󕶎Ƃ
//  AMsg
//    UNLHA32.DLLԂbZ[W
//=============================================================================
function TplArchieverLZH.MakeSFX(SrcPath, DestPath: String;
  AutoRunFile: String; var AMsg: String): Boolean;
var
  FCommand    : String;
  ADestPath   : String;
  SavePath    : String;
  SL          : TStringList;
begin
  Result := False;
  //DLL[hłĂȂ[hɎs
  if FDllHandle = 0 then exit;
  //쐬̃t@CȂ
  if FileExists(SrcPath) = False then exit;

  ADestPath := ExtractFileName(DestPath);
  if Trim(ADestPath) = '' then 
    ADestPath := ChangeFileExt(ExtractFileName(SrcPath), '.EXE');

  FCommand := 's -gx11 -gw4 '+ AddQuotedStr(SrcPath) +
              ' -x1 -r2 -gr' + AddQuotedStr(ADestPath);

  Result := True;
  if AutoRunFile <> '' then begin
    SL := TStringList.Create;
    SavePath := ExtractFilePath(SrcPath) + '$';

    try
      SL.Add('$Command=' + AddQuotedStr(AutoRunFile));
      SL.SaveToFile(SavePath);
      //^Ċ֐s(𓀎̎spt@C̒ǉ)
      Result := Execute('a '+ SrcPath + ' ' + AddQuotedStr(SavePath), AMsg);
    finally
      DeleteFile(SavePath);
      FreeAndNil(SL);
    end;
  end;

  //^Ċ֐s
  if Result then begin
    AMsg := '';
    Result := Execute(FCommand, AMsg);
  end;
end;

//=============================================================================
//  k܂͉𓀂̎s[`
//  k𓀂͈̃R}hŌ܂
//  AMsgɌʂ̕߂
//  ȂꍇłCAMsg̏ꍇ̂Œ
//
//  UNLHA32.DLLUnicode(jR[h)Ήł͂Ȃ̂ŁC̊֐ł͕
//  AnsiStringɕϊĂ
//=============================================================================
function TplArchieverLZH.Execute(Cmd: String; var AMsg: String): Boolean;
var
  ACommand : AnsiString;
  Output   : array[0..BUFF_SIZE-1] of AnsiChar;
begin
  Result := False;

  if @FUnlha <> nil then begin
    FillChar(Output, SizeOf(Output), 0);
    //qgx\̂ŖIɃLXgĂ
    ACommand := AnsiString(Cmd);
    try
      FUnlha(FHandle, PAnsiChar(ACommand), OutPut, BUFF_SIZE);
      Result := True;
    except
    end;
  end;
  AMsg := String(OutPut);
end;

//=============================================================================
//  UNLHA32.DLL̃o[W擾
//=============================================================================
function TplArchieverLZH.GetVersion: String;
var
  VerWORD : WORD;
begin
  if @FUnlhaGetVersion <> nil then begin
    try
      VerWORD := FUnlhaGetVersion;
      Result  := 'Ver. ' + FormatFloat('#.##' , VerWORD / 100);
    except
    end;
  end;
end;

//=============================================================================
//  PathList̃tpX񂩂C擪vfBNg؏o
//  PathListɂ͂fBNg폜pXԂ
//
//  t@C̃Xg̊fBNg擾
//  k͂̊fBNgKwɂ̂Ɖ肷
//  pXrĈԒẐfBNgƂ
//  Ôߐ擪̃fBNgŔr
//  ŔrD:\000\BBBBBBD:\000\A\C Ƃł͌҂ZȂĂ܂
//
//  UNLHA32.DLLɂ̓t@C̐CR}hCł̃p[^
//  2048Ȃ̂ŁCfBNg̃t@C̓tpXőSė^̂ł͂ȂC
//  fBNg^悢D̐̓X|Xt@CgΎ
//  p[^ɐ͂ȂȂ
//=============================================================================
function TplArchieverLZH.GetBasePath(PathList: TStrings): String;
var
  i     : integer;
  APath : String;
  Str   : String;
  ALen  : Integer;
begin
  Result := '';
  if (PathList.Count = 0) then exit;;

  //ExtractFileDirł͍Xɏ̊KwɂȂĂ܂
  APath := ExtractFilePath(ExcludeTrailingPathDelimiter(PathList[0]));

  for i := 0 to PathList.Count - 1 do begin
    Str := ExtractFilePath(ExcludeTrailingPathDelimiter(PathList[i]));

    //APath̕r
    //ȂꍇStr̕ZpXȂ̂APath1̊KwɈړĒZ
    //v܂ŌJԂ
    while True do begin
      ALen := Length(APath);
      if (Copy(Str, 1, ALen) = APath) then begin
        break;
      end else begin
        APath := ExtractFilePath(ExcludeTrailingPathDelimiter(APath));
      end;
    end;
  end;
  Result := APath;

  //fBNgKw̃t@CfBNĝ݂ΏۂƂ̂
  //fBNgpXPahtListɊi[
  ALen := Length(Result);
  for i := 0 to PathList.Count - 1 do begin
    Str := PathList[i];
    if Copy(Str, 1, ALen) = Result then begin
      System.Delete(Str, 1, ALen);
      PathList[i] := Str;
    end;
  end;
end;

//=============================================================================
//  "(_uR[e[V)ň͂񂾕쐬֐
//=============================================================================
function TplArchieverLZH.AddQuotedStr(Str: String): String;
begin
  Result := SysUtils.AnsiQuotedStr(Str, '"');
end;

end.
